#! /bin/sh
#
#   erase.sh -- ǡ񤭤ƾä
#
#	0.0: Oct. 30, 2001 by Dai ISHIJIMA (e.sh, for v00)
#	0.1: Oct. 22, 2002 (for v01, variable disk size)
#	0.2: May   1, 2004 (for v02, 0, 1, random)
#	0.3: Jun. 20, 2004 (for v03, menu/floppy)
#	0.4: Feb. 17, 2007 (for v08, ѥ)
#	0.5: May  17, 2020 (for v20, FreeBSD 11.3R)
#	0.6: Dec. 25, 2022 (for ubuntu)
#

stuff="${1:--z}"
disk="${2:-ada0}"

if [ ! -w /dev/$disk ]; then
	echo "$0: disk $disk not found or non-writable"
	echo -n "Ok? [y/n]: "
	read ans
	case x"$ans" in
		xy*)	;;
		*)	echo 'canceled'; exit 1;;
	esac
fi

if df | grep "^/dev/$disk" > /dev/null 2>&1 ; then
	echo "$0: disk $disk is mounted, proceed?"
	echo -n "Ok? [yes/no]: "
	read ans
	case x"$ans" in
		xyes)	;;
		*)	echo 'canceled'; exit 1;;
	esac
fi

dmesg=/var/run/dmesg.boot
#dname=`sed -n -E "/^${disk}:.*<.*>/p" $dmesg | sed 's/.*\(<.*>\).*/\1/'`
bytes=`sh disksize.sh -b $disk`
cbytes=`sh disksize.sh -c $disk`
cap=`sh disksize.sh -s $disk`

echo ''; echo ''; echo ''
#echo "*** erase data on ${disk} ${dname}, ${bytes} bytes"
echo "*** erase data on ${disk} ${cap}, ${cbytes} bytes"
echo -n "    with "
case x"$stuff" in
	x-[0z])
		method='write 0'
		echo "writing '0' onto the disk"
		;;
	x-[1f])
		method='write 1'
		echo "writing '1' onto the disk"
		;;
	x-[Rr])
		method='write random'
		echo "writing random data onto the disk"
		;;
	x-[Pp])
		stuff -g > $PATTERNFIL
		method='write pattern'
		echo "writing random pattern onto the disk"
		;;
	x-[Qq])
		method='write inverted pattern'
		echo "writing inverted pattern onto the disk"
		;;
esac

echo -n "[Q:1/2] Ok? [y/n]: "
read ans
case x"$ans" in
	xy)	;;
	*)	echo 'canceled'; exit 1;;
esac

echo -n "[Q:2/2] Really? [yes/no]: "
read ans
case x"$ans" in
	xyes)	;;
	*)	echo 'canceled'; exit 1;;
esac


# õΥѥ᡼
bytes=`sh disksize.sh -b $disk`
obs=$(( 1024 * 1024 ))
ibs=1024
icnt=32768
ocnt=32
max=$(( ( $bytes + $obs - 1 ) / $obs ))

#
echo ''

echo ''; echo ''; echo ''; echo ''; echo '';
echo ''; echo ''; echo ''; echo ''; echo '';
printf "\033"
echo -n '[10A'
printf "\033"
echo -n '7'

startsec=`date '+%s'`
rems='??? [min]'

skip=0
while [ $skip -le $max ]; do
	# 
	printf "\033"
	echo -n '8'
	printf "\033"
	echo -n '7'
	# ׻
	cursec=`date '+%s'`
	# С
	p=$(( 100 * $skip / $max ))
	m=$(( 1000 * $skip / $max ))
	q=$(( $p / 2 ))
	i=0
	bar=''
	while [ $i -lt $q ]; do
		bar="$bar"'#'
		i=$(( $i + 1 ))
	done
	while [ $i -lt 50 ]; do
		bar="$bar"'_'
		i=$(( $i + 1 ))
	done
	#
	# Ĥ
	elapsed=$(( $cursec - $startsec ))
	if [ $m -gt 0 ]; then
		remain=$(( ( 1000 - $m ) * $elapsed / $m + 1 ))
		if [ $remain -gt 120 ]; then
			rems=$(( ( $remain + 59 ) / 60 ))
			rems="${rems} [min]"
		else
			rems="${remain} [sec]"
		fi
	fi
	if [ $elapsed -gt 120 ]; then
		elas=$(( ( $elapsed + 30 ) / 60 ))
		elas="${elas} [min]"
	else
		elas="${elapsed} [sec]"
	fi
	#
	echo "erasing data on disk: ${disk}.  ${p}% done"
	echo "${elas} elapsed, ${rems} remains (approx.)   "
	echo ''
	echo "    0%|${bar}|100%"
	echo ''
	case x$DEBUG in
	    x[Yy]*)
		echo 'now in debug mode...'
		sleep 1
		;;
	    *)
		./stuff $stuff < $PATTERNFIL |
		dd ibs=$ibs obs=$obs seek=$skip count=$icnt of=/dev/$disk
		;;
	esac
	# 롼
	skip=$(( $skip + $ocnt ))
done

echo ''; echo ''; echo ''; echo ''; echo ''

cursec=`date '+%s'`
elapsed=$(( $cursec - $startsec ))
if [ $elapsed -gt 120 ]; then
	min=$(( $elapsed / 60 ))
	sec=$(( $elapsed - $min * 60 ))
	elas="${min} [min] ${sec} [sec]"
else
	elas="${elapsed} [sec]"
fi

echo 'The contents of this storage device' > /tmp/erase-log.$disk
echo "$disk ($cap) '$dname'" >> /tmp/erase-log.$disk
echo -n 'were erased with ' >> /tmp/erase-log.$disk
echo 'hard disk wiping tool "wipe-out."' >> /tmp/erase-log.$disk
echo "Erased with '$method'" >> /tmp/erase-log.$disk
echo " epoch: $startsec -> $cursec" >> /tmp/erase-log.$disk

echo "but NOT verified" > /tmp/verify-log.$disk

echo "completed ($elas)"
echo ''
echo -n 'Press ENTER to return menu...'
read x

exit 0

# EOF
